/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 * 
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation. Portions created by Netscape are
 * Copyright (C) 1998-1999 Netscape Communications Corporation. All
 * Rights Reserved.
 */

// This is where functions related to the quick reply box live.

// Frank DiLecce - renaming all variables so that they do not conflict with existing vars
var QRglobals = {
    temp1: '',
    temp2: '',
    sQRMessagesBundle: '',      //points to quick reply's properties file
    // services
    sIOService: '',
    sAccountManager: '',
    // general vars    
    gHeldButtonLabel: '',       //a holder for the 'Show Quick Reply' button label text, held when we change the text to 'Hide Quick Reply' - Frank DiLecce
    gAltProgress: '',           //an Alternate percent done Var - Frank DiLecce
    gSendNow: '',               //SendNow is now global, for charset and editor support - Frank DiLecce
    gSrcMsgURI: '',             //SrcMsgURI is now global, for charset and editor support - Frank DiLecce
    gTypedBdy: '',              //typed body is now global, for charset and editor support - Frank DiLecce
    gTempEditorWindow: '',      //points to the temporary window we created with an 'active' editor on the document - Frank DiLecce
    gMsgCompose: '',            //gMsgCompose is now global, for charset and editor support - Frank DiLecce
    gRecips: '',                //recipients of message being replied to
    gCCList: '',                //CC list of message being replied to
    gIdentity: '',              //Identity that will be used for the reply
    gDebugLevel: 0,             //current debug level
    gFocusOnBox: false,
    gHideTemp: true,

    // observers - listeners
    gMsgEditorCreationObserver: { 
            // This function is triggered when a new editor has been created
            observe: function(aSubject, aTopic, aData) {
                if (aTopic == "obs_documentCreated") {
                    QRglobals.debug(20, 'gMsgEditorCreationObserver: getting and Initing Current Editor');
                    var editor = GetCurrentEditor();
                    if (editor) {
                        // ok we have gotten an editor, lets send the message
                        QRglobals.gMsgCompose.initEditor(editor, window.content);
                        QRglobals.DoSend();
                    }
                }
            }
        },
    
    saveDefaultPrefs: function() {
            // this function would only run if the quickreply.debug pref does NOT exist
            //  this was added because I found that if the user did NOT go into settings right after installing Quick Reply
            //  the QuickReply extension would fail - Frank DiLecce
        	pref.setIntPref("quickreply.debug", 0);
        	QRglobals.debug(20, 'saveDefaultPrefs: started');
        	pref.setBoolPref("quickreply.deleteaftersend", true);
        	pref.setBoolPref("quickreply.KeepOpen", false);
        	pref.setBoolPref("quickreply.PositionBoxOnTop", false);
        	pref.setBoolPref("quickreply.display_mailWindow", false);
        	pref.setBoolPref("quickreply.hide_tempWindow", false);
        	pref.setIntPref("quickreply.ident", 1);
        	pref.setIntPref("quickreply.quoting", 0);
        	pref.setIntPref("quickreply.signature", 0);
        	QRglobals.debug(20, 'saveDefaultPrefs: Saved Default Preferences !!');
        },

    debug: function(level, message) {
            // debug levels:
            //	5:	important information is logged, including catches. (not very much shown)
            //	10:	non-default paths are logged
            // 	20:	all function starts get shown
            //	25:	all key presses in text box are also shown. (all debug messages shown)
            try {
        	   QRglobals.gDebugLevel = pref.getIntPref( 'quickreply.debug' );
            } catch(e) {
                // If the debug level pref was unavailable, we can only assume no default prefs were set.. lets set them now - Frank DiLecce
               QRglobals.saveDefaultPrefs();
            }
        	if( level > QRglobals.gDebugLevel ) { return; }
            //moved this down here so that console would only be interrupted if in debugging mode - Frank DiLecce
            var sConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
        	sConsoleService.logStringMessage('QR: '+message);
        },

    setFocusToQRTextInput: function(tgt) {
            // this function will put the insertion point in the open QR input box
	        QRglobals.debug(20, 'setFocusToQRTextInput: started');
            var QRBox = document.getElementById('quickReplyInput' + QRglobals.GetQRBoxPosition())
            if (!QRBox.parentNode.collapsed) {
                QRBox.focus();
            } else {
                if (document.documentURI.indexOf('indow') == -1) MsgToggleMessagePane();
            }
        },
        
    KeepQROpen: function() {
            // added this function so we can see if the user choose to keep the QR box open all the time
            var QRKeepOpen;
        	try {
        		QRKeepOpen = pref.getBoolPref( 'quickreply.KeepOpen');
        	} catch (e) {
        		QRglobals.debug(5,'QRKeepOpen: exception "'+e+'" caught when accessing preference quickreply.KeepOpen');
        		QRKeepOpen = false;
        		pref.setBoolPref( 'quickreply.KeepOpen', false );
        	}
        	QRglobals.debug(20, 'QRKeepOpen: Ending with KeepOpen = ' + QRKeepOpen);
            return QRKeepOpen;
        },

    initQRMenuItem: function(tgt) {
            // this function will set the checkmark on the menu item when the menu is opened
    	    QRglobals.debug(20, 'initQRMenuItem: started');
            var viewQuickReplyToolbar = QRglobals.getViewQuickReplyToolbar(tgt);
            document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", viewQuickReplyToolbar ? "true" : "false");
            QRglobals.debug(20, 'initQRMenuItem: Ending with QR_MenuItem checked = ' + viewQuickReplyToolbar ? "true" : "false");
        },

    getViewQuickReplyToolbar: function(tgt) {
        	QRglobals.debug(20, 'getViewQuickReplyToolbar: started');
            var viewQuickReplyToolbar = false;
        	try {
        	    viewQuickReplyToolbar = pref.getBoolPref( 'quickreply.display_' + tgt );
        	} catch (e) {
        		QRglobals.debug(5,'getViewQuickReplyToolbar: exception "'+e+'" caught when accessing preference quickreply.display_' + tgt + "Setting it false");
        	    pref.setBoolPref("quickreply.display_mailWindow", viewQuickReplyToolbar);
        	}
        	QRglobals.debug(20, 'getViewQuickReplyToolbar: Ending with viewQuickReplyToolbar = ' + viewQuickReplyToolbar );
        	return viewQuickReplyToolbar;
        },

    setViewQuickReplyToolbar: function(tgt,viewQuickReplyToolbar) {
            // this function should set the pref and menu item checkmark - Frank DiLecce
        	QRglobals.debug(20, 'setViewQuickReplyToolbar: started, going to set it ' + viewQuickReplyToolbar);
        	if(viewQuickReplyToolbar) {
       			document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", "true");
        	} else {
        		document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", "false");
        	}
        	pref.setBoolPref( 'quickreply.display_' + tgt, viewQuickReplyToolbar );
        },

    toggleQuickReplyMenuItem: function(tgt) {
            // this is called from the menu, it sets the QuickReply box visibility
        	QRglobals.debug(20, 'toggleQuickReplyMenuItem: started');
            // this function now just hands off to toggleQuickReplyButton because it should all be done in one place - Frank DiLecce
            QRglobals.toggleQuickReplyButton(tgt);
        },

    toggleQuickReplyButton: function(tgt) {
            // we are actually gonna use the button label to set and retrieve QuickReply visibility state - Frank DiLecce
        	QRglobals.debug(20, 'toggleQuickReplyButton: started');
            var toggleButton = document.getElementById("quickReplyToggleButton");   // the button on extendedview
            var toggleHidden = document.getElementById("quickReplyHiddenText");     // hidden text label contains the opposite of "Show Quick View"
            if (toggleButton.label != toggleHidden.value) {
                QRglobals.gHeldButtonLabel = toggleButton.label
                toggleButton.label = toggleHidden.value;
                QRglobals.ShowQuickReplyBox(tgt);
                QRglobals.gFocusOnBox = false;
                // check the pref to see if we should set the focus on the box
            	try {
            		QRshowNfocus = pref.getBoolPref( 'quickreply.showNfocus');
            	} catch (e) {
            		QRglobals.debug(5,'QRtoggleQuickReplyButton: exception "'+e+'" caught when accessing preference quickreply.showNfocus');
            		QRshowNfocus = false;
            		pref.setBoolPref( 'quickreply.showNfocus', false );
            	}
                QRglobals.gFocusOnBox = QRshowNfocus;
            	QRglobals.debug(20, 'toggleQuickReplyButton: Ending - Going To Show the box');
            } else {
                toggleButton.label = QRglobals.gHeldButtonLabel
                QRglobals.HideQuickReplyBox(tgt);
        	    QRglobals.debug(20, 'toggleQuickReplyButton: Ending - Going To Hide the box');
            }
        },

    GetQRBoxPosition: function() {
            // this function gets the pref setting for whether the user wants the QRBox above or below the messagetext
            // the function returns:
            // a blank string for top
            // a number 2 as text for bottom
            var boxNum;
        	var boxPosTop = false;
            try {
                boxPosTop = pref.getBoolPref( 'quickreply.PositionBoxOnTop' );
        	} catch (e) {
        		QRglobals.debug(5,'ShowQuickReplyBox: exception "'+e+'" caught when accessing preference quickreply.PositionOnTop, setting false');
        		pref.setBoolPref( 'quickreply.PositionBoxOnTop', boxPosTop );
        	}
            if (boxPosTop) { boxNum = ''; } else { boxNum = '2'; } 
            //QRglobals.debug(20, 'GetQRBoxPosition: Ending - BoxOnTop = ' + boxPosTop);
            return boxNum;
        },

    ShowQuickReplyBox: function(tgt) {
        	QRglobals.debug(20, 'ShowQuickReplyBox: started');
        	var box = document.getElementById( 'msgQuickReply_' + tgt + QRglobals.GetQRBoxPosition());
        	var box1 = document.getElementById( 'msgQuickReply_' + tgt);
        	var box2 = document.getElementById( 'msgQuickReply_' + tgt + '2');
        	if (box) {
                var collHeaderView = document.getElementById("collapsedHeaderView");    
                var expHeaderView = document.getElementById("expandedHeaderView");    
                if (collHeaderView.collapsed  && expHeaderView.collapsed) {
                    // we don't want the Quick Reply Box to be shown if there is no message shown
            	    QRglobals.debug(20, 'ShowQuickReplyBox: UNcollapsing msgQuickReply_' + tgt + QRglobals.GetQRBoxPosition() + ', but no message');
                } else {
            	    QRglobals.debug(20, 'ShowQuickReplyBox: UNcollapsing msgQuickReply_' + tgt + QRglobals.GetQRBoxPosition());
                    // Just collapse both first, so we can be assured the only one that is uncollapsed is the correct one
                    box1.collapsed = true; 
                    box2.collapsed = true; 
                    box.collapsed = false; 
                    if (QRglobals.gFocusOnBox) {
                        QRglobals.setFocusToQRTextInput('mailWindow');
                        QRglobals.gFocusOnBox = false;
                    }
                }
                // we set the pref from here now - Frank DiLecce
                QRglobals.setViewQuickReplyToolbar(tgt,true);
            }
        }, 
        
    HideQuickReplyBox: function(tgt) { 
        	QRglobals.debug(20, 'HideQuickReplyBox: started');
        	var box = document.getElementById('msgQuickReply_' + tgt );
        	var box2 = document.getElementById('msgQuickReply_' + tgt + '2');
        	if (box) {
                box.collapsed = true;
                box2.collapsed = true;
                QRglobals.setViewQuickReplyToolbar(tgt,false);
                // lets clear the QuickReply textbox here so user does't get surprised later on when he shows it again - Frank DiLecce
                document.getElementById("quickReplyInput").value="";
                document.getElementById("quickReplyInput2").value="";
            }
        },
        
    QRSetBoxCollapseState: function(tgt) {
            // this function will 
        	QRglobals.debug(20, 'QRSetBoxCollapseState: started');
            var box = document.getElementById('msgQuickReply_' + tgt + QRglobals.GetQRBoxPosition());
            var toggleButton = document.getElementById("quickReplyToggleButton");
            var toggleHidden = document.getElementById("quickReplyHiddenText");
            var collHeaderView = document.getElementById("collapsedHeaderView");    
            var expHeaderView = document.getElementById("expandedHeaderView");    
            if (collHeaderView.collapsed  && expHeaderView.collapsed) {
                // we don't want the Quick Reply Box to be shown if there is no message shown
            	if (box) box.collapsed = true;
            	QRglobals.debug(20, 'QRSetBoxCollapseState: Ending - QRBox was collapsed, both headers are collapsed');
            } else {
                if (toggleButton.label == toggleHidden.value) {
                    QRglobals.ShowQuickReplyBox(tgt);
                	QRglobals.debug(20, 'QRSetBoxCollapseState: Ending - QRBox UNcollapsed as per QR button');
                } else {
                    QRglobals.HideQuickReplyBox(tgt);
                	QRglobals.debug(20, 'QRSetBoxCollapseState: Ending - QRBox UNcollapsed as per QR button');
                }
            }
        },
        
    disableQR: function() {
            // this function is called in the doReply function - Frank DiLecce ( added comment only )
        	QRglobals.debug(20, 'disableQR: started');
        	document.getElementById("QRsendButton"+ QRglobals.GetQRBoxPosition()).disabled=true;
        	document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).disabled=true;
        },
        
    enableQR: function() {
            // this function is called in the doReply function - Frank DiLecce ( added comment only )
        	QRglobals.debug(20, 'enableQR: started');
        	document.getElementById("QRsendButton"+ QRglobals.GetQRBoxPosition()).disabled=false;
        	document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).disabled=false;
        },
        
    clearQR: function() {
            // this function is called in the doReply function if the option for it is ticked - Frank DiLecce 
        	QRglobals.debug(20, 'clearQR: started - going to clear the QR input boxes');
        	try {
        		if( pref.getBoolPref( 'quickreply.deleteaftersend') )
        			document.getElementById("quickReplyInput").value="";
        			document.getElementById("quickReplyInput2").value="";
        	} catch(e) {
        		QRglobals.debug(5,'clearQR: exception "'+e+'" caught when accessing preference quickreply.deleteaftersend, setting it true and clearing QR input boxes');
                pref.setBoolPref( 'quickreply.deleteaftersend', true)
        		document.getElementById("quickReplyInput").value="";
        		document.getElementById("quickReplyInput2").value="";
        	}
        },
        
    doQRTextBoxKeyPress: function(e, tgt) {
            // this function observes key presses in the QR input box, it is responsible for :
            //  ctrl-enter  - initiate send
            //  tab         - insert tab in input box
            //  ctrl+       - make input box text bigger
            //  ctrl-       - make input box text smaller
      		var textbox = document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition())
      		var curFontSize = 11;
        	try {
    			curFontSize = pref.getIntPref('quickreply.textBoxFontSize');
    	    } catch (e) {
    		    QRglobals.debug(5,'QR: keypress increase font size: exception "'+e+'" caught when accessing preference quickreply.textBoxFontSize');
    			pref.setIntPref( 'quickreply.textBoxFontSize', curFontSize );
    	    }
            textbox.setAttribute("style", "font-size: " + curFontSize + "px");
                        
        	QRglobals.debug(25, 'doQRTextBoxKeyPress: '+e.type+"|ctrl:"+e.ctrlKey+"|alt:"+e.altKey+"|keyCode:"+e.keyCode+"|charCode:"+e.charCode+"|which:"+e.which);
        	if(e.ctrlKey == true && e.altKey == false && e.metaKey == false && e.which== 13 ) { // Enter: 13
        		// ctrl+enter --> send; check if that's ok.
        		QRglobals.disableQR();
        		if (!QRglobals.maybeWarnOnSend() ) {
        			QRglobals.enableQR();
        			return;
        		}
        		QRglobals.doQuickReply(e, tgt);	// just pass the same event - saves the hassle.
        	} else if(e.ctrlKey == false && e.altKey == false && e.metaKey == false && e.keyCode == 9) {
        		// tab: insert tab character.
        		e.preventDefault();
        		var content = textbox.value;
        		var selStart = textbox.selectionStart;
        		var selEnd = textbox.selectionEnd;
        		textbox.value = content.substr(0, selStart )+"\t"+content.substr(selEnd, content.length );
        		textbox.setSelectionRange( selStart+1, selStart+1);
        	} else if((e.ctrlKey == true || e.metaKey == true) && e.altKey == false  && e.charCode == 43) {
        		// plus: increase the font size.
        		e.preventDefault();
        		var newFontSize = ++curFontSize;
        		if (newFontSize > 40) return;
      			pref.setIntPref( 'quickreply.textBoxFontSize', newFontSize );
                textbox.setAttribute("style", "font-size: " + newFontSize + "px");
        	} else if((e.ctrlKey == true || e.metaKey == true) && e.altKey == false && e.charCode == 45) {
        		// minus: decrease the font size.
        		e.preventDefault();
        		var newFontSize = --curFontSize;
        		if (newFontSize < 9) return;
      			pref.setIntPref( 'quickreply.textBoxFontSize', newFontSize );
                textbox.setAttribute("style", "font-size: " + newFontSize + "px");
        	}
        },
        
    ShowPref: function(tgt) {
            // This function shows the options panel - Frank DiLecce ( added comment only )
        	QRglobals.debug(20, 'ShowPref: started');
        	window.openDialog('chrome://messenger-quickreply/content/prefQuickReply.xul', 'messenger-quickreply-pref', 'chrome');
        },
        
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Below this line are all the functions to do with sending
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////
    

    getActiveQuoteChoice: function() {
            // getActiveQuoteChoice
            // depending on preferences > quickreply.quote:
        	//   0: Honour the account's quote preference
        	//   1: Don't add a quote (default)
        	//   2: Add the quote above 
        	//   3: Add the quote below
            // function returns :
            //   0: no quote
            //   1: reply above quote
            //   2: reply below quote
        
        	QRglobals.debug(10, 'getActiveQuoteChoice: started');
        	var shouldQuotePref
        	var retval;
            var currentIdentity = QRglobals.gIdentity;
        	// shouldQuotePref:
        	// 0: use system pref, 1: don't, 2: above, 3: below
        	try {
        			shouldQuotePref = pref.getIntPref('quickreply.quoting');
        	} catch (e) {
        		    QRglobals.debug(5,'getActiveQuoteChoice: exception "'+e+'" caught when accessing preference quickreply.quoting, setting it to -add quote above reply-');
        			shouldQuotePref = 2;
        			pref.setIntPref( 'quickreply.quoting', shouldQuotePref );
        	}
        	if( shouldQuotePref == 0 ) {
        		// mail.autoqoute defaults to true!
        		retval = -1;
        		try {
        			// should we quote or not?
                    //  changed the next line because quoting is account specific - Frank DiLecce
        			if( false == pref.getBoolPref("mail.identity." + currentIdentity.key + ".auto_quote") ) {
        				retval = 0;
        			} 
        		} catch(e) {
        			QRglobals.debug(5,'getActiveQuoteChoice: exception "'+e+'" caught when accessing preference mail.identity.' + currentIdentity.key + '.autoquote');
                    // autoquote might not exist 
        		}
        		// we should quote, maybe. now, let's find out where.
        		if( retval == -1 ) {
        			try {
        				// if the pref is there, it's either 1 (below) or 2 (select text)
                        //  changed the next line because reply_on_top is account specific - Frank DiLecce
          				switch( pref.getIntPref("mail.identity." + currentIdentity.key + ".reply_on_top") ) {
        					case 0: retval = 2; break;	// reply_on_top 0 = reply below quote
        					case 1: retval = 1; break;	// reply_on_top 1 = reply above quote
        					case 2: retval = 1; break;// select - interpret as above (we need to do something...)
        					default: retval = 1;
        				}
        			} catch(e) {
        				// if the getting fails, the pref is not there - and then we need to quote below.
        				QRglobals.debug(5,'getActiveQuoteChoice: exception "'+e+'" caught when accessing preference mail.identity.' + currentIdentity.key + '.reply_on_top');
        				retval = 0;
        			}
        		}
        	} else {
        		retval = shouldQuotePref -1;
        	}
            QRglobals.debug(10, 'getActiveQuoteChoice: Ending - Return value = ' + retval);
        	return retval;
        },
    
    
    getActiveSigChoice: function(identity) {
            // getActiveSigChoice
            // depending on preferences, 
            //  This function is no longer useful.  Because we now have an editor involved (for charset and wrapping support), TB now takes care of the Sig for us
            // I am leaving it in (as I am for all other references to it) incase later on we figure we want this feature back - Frank DiLecce
        	QRglobals.debug(20, 'getActiveSigChoice: started');
        	var retval
        	var sigpref;
        	// quickreply.signature:
        	//   0: Honour the account's signature preference
        	//   1: Don't add a signature (default)
        	//   2: Add the signature at the bottom of the email
        	//   3: Add the signature directly below my text
            // returns :
            //   0: no sig
            //   1: sig at bottom of mail
            //   2: sig at bottom of typed text
        	try {
        		sigpref = pref.getIntPref('quickreply.signature');
        	} catch (e) {
        		QRglobals.debug(5,'getActiveSigChoice: exception "'+e+'" caught when accessing preference quickreply.signature, setting to -sig at bottom-');
        		sigpref = 1;
        		pref.setBoolPref( 'quickreply.signature', sigpref );
        	}
        	if( sigpref == 0 ) {
        		// if the pref says FALSE, don't add it (0)
        		// if the pref says TRUE,  add it as follows:
        		// if identity.sig_Bottom is not defined, then add at bottom (1)
        		// if identity.sig_Bottom is defined and true, then add at bottom (1)
        		// if identity.sig_Bottom is defined and false, then add directly below my text (2)
        		if( identity.attachSignature ) {
        			if( identity.sigBottom === undefined ) { // sigBottom is not defined - possibly have an old TB.
        				retval = 0;
        			} else {
                        // sigbottom false = sig below the reply above quote if any
                        // sigbottom true = reply on top, sig below quote 
        				retval = ( identity.sigBottom ? 1 : 2 );
        			}
        		} else {
        			retval = 0;
        		}
        	} else {
        		retval = sigpref - 1; // what a coincidence...
        	}
        	QRglobals.debug(20, 'getActiveSigChoice: Ending - Return value =' + retval);
        	return retval;
        },
    
    getCurrentIdentity: function(mode) {
        	QRglobals.debug(20, 'getCurrentIdentity: started');
        	if (mode == 'initial') {
                QRglobals.gIdentity = null; // initialize 
                var ccs = '';
                // first lets try to get the identity used in the message ( an alias ?)
                // lets try to figure out the ident based on the recipient or cc field in the header of the message we are replying to
                if (QRglobals.gRecips == QRglobals.gCCList) QRglobals.gRecips = '';           // if there was no to: specified, only CCs
                if (QRglobals.gRecips != '') { ccs = QRglobals.gRecips + ', '; }  // add all recipients in case there are more than one
                ccs += QRglobals.gCCList;                               // add all the people in the cc list
                var allIdents = QRglobals.sAccountManager.allIdentities;
               	var compfields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
                var arr = compfields.SplitRecipients(ccs, false);  // split up the recips so we don't have to deal with commas
                for ( var index = 0; index < arr.count; index++ ) {
                    recip = null;
                    recip = arr.StringAt(index);
                    for (j= 0; j < allIdents.Count() ; j++ ) {
                        var ident = allIdents.GetElementAt(j);
                        ident instanceof Components.interfaces.nsIMsgIdentity;
                        if (recip.toLowerCase().indexOf(ident.email.toLowerCase()) > -1) {
                            // this is a match to one of our identities
                            identity = ident;
                            break;
                        }
                    }
                }  
        	}
            // Then lets try to get the identity tied to the currently loaded folder
            if (!identity) {
        	   var server = GetLoadedMsgFolder().server;
        	   var identity = QRglobals.sAccountManager.getFirstIdentityForServer( server );
        	}
            // if identity is still blank, lets use the one from prefs - Frank DiLecce
        	if (!identity) {
                identity = QRglobals.sAccountManager.getIdentity("id" + pref.getIntPref( 'quickreply.ident' ));
        		QRglobals.debug(10, 'Default identity was blank, using pref Identity');
            }
        	QRglobals.debug(20, 'getCurrentIdentity: Ending, Identity is '+identity);
            QRglobals.gIdentity = identity;
        	return identity;
        },
        
    setStatus: function(newStatus) {
        	document.getElementById("statusText").setAttribute("label", newStatus);
        },
                
    getQuotedOriginal: function(author) {
            //	This returns the original message (or a selected part) quoted for inclusion in the reply
        	QRglobals.debug(20, 'getQuotedOriginal: started');
        	// try to get selection from the message pane
        	var composeMsgsBundle = document.getElementById("bundle_composeMessages");
        	//var messagepaneframe = window.content;
        	var messagepaneframe = document.getElementById("messagepane").contentDocument;
        	var selection = messagepaneframe.getSelection();
        	var selectiontext = selection.toString();
        	if (selectiontext == "") {
        		// if no selection, quote the whole document...
        		QRglobals.temp1 = window.getSelection();
        		var tempV = QRglobals.temp1.selectAllChildren(messagepaneframe.body);
        		QRglobals.temp1 = window.getSelection();
        		selectiontext = QRglobals.temp1.toString();
        	}
        	// say who wrote the quoted part
        	var authorwrote;
        	try {
        		authorwrote = composeMsgsBundle.getString('mailnews.reply_header_authorwrote')
        	} catch(e) {
        		QRglobals.debug(5,'getQuotedOriginal: exception "'+e+'" caught when accessing message mailnews.reply_header_authorwrote' );
        		authorwrote = '';
        	}
        	var quoteauthor;
        	if( authorwrote == '' ) {
        		quoteauthor = author;
        	} else {
        	 	quoteauthor = authorwrote.replace( '%s', author ) + ':';
        	}
        	// Add an indentCharacter at the beginning of each line.
        	// The indentCharacter should be localised in the main app, but I can't find where - pending that, it's in our
        	// personal properties. The indentCharacter defaults to '> '.
        	var indentCharacter;
        	try {
        		indentCharacter = document.getElementById("bundle_quickreplyMessages").getString('indentCharacter');
        	} catch (e) {
        		QRglobals.debug(5,'getViewQuickReplyToolbar: exception "'+e+'" caught when getting string indentCharacter' );
        		indentCharacter = '>';
        	}
        	//indentCharacter += " ";
            var quotedsection = "";
            var eolpos = 0;
            var endofline = new RegExp("$", "m");
            var stilltoreplace = selectiontext;
            while (stilltoreplace != "") {
        		eolpos = stilltoreplace.search(endofline);
        		if (eolpos >= 0) {
        		    if (stilltoreplace.substring(0,3) == "-- ") break;
        			quotedsection = quotedsection + indentCharacter + stilltoreplace.slice(0, eolpos + 2);
        			stilltoreplace = stilltoreplace.slice(eolpos + 2);
        		} else {
        			quotedsection = quotedsection + indentCharacter + stilltoreplace;
        		}
            }
        	// put them all together...
        	QRglobals.debug(20, 'getQuotedOriginal: Ending, quoted text follows:' + quoteauthor + "\n" + quotedsection + "\n" );
        	return quoteauthor + "\n" + quotedsection + "\n";
        },
    
    doQuickReply: function(e, tgt) {
            //	This function is called by either clicking the send button or pressing ctrl-enter in the input box.
            //	e: event that caused this click.
            var sendNow = e.shiftKey == false;
        	QRglobals.debug(10, 'doQuickReply: started');
        	if (document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).value == null ||
    			document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).value == "")	{
    			QRglobals.debug(5, 'doQuickReply: nothing to reply with - returning');
    			return;
        	}	
        	var srcMsgHdr = '';
        	var dest = '';
        	var newsgroups= '';
        	var author = '';
        	var bdy = '';
        	var typedbdy = '';
        	var identity = '';;
        	QRglobals.disableQR();
        	var srcMsgURI = GetLoadedMessage();
        	try {
        		srcMsgHdr = messenger.messageServiceFromURI(srcMsgURI).messageURIToMsgHdr(srcMsgURI);
        	} catch (ex) {
                QRglobals.debug(5,'doQuickReply: exception "'+ex+'" caught when trying to get message header for URI '+srcMsgURI+'.' );
                QRglobals.enableQR();
        		return;
        	}
        	var srcMsgId = srcMsgHdr.messageId;
        	var subj = srcMsgHdr.subject; 
        
        	// dwlt: is this localized in the main Mozilla app? If so, is there a way to request this value?
        	//		::can't find it in the main components anywhere, but haven't looked in the C++ source base
        	//		::if we can't find it there, we should just put in the quickreply.properties file
        	
        	// Frank DiLecce : Re: is NOT localized.. it is hard coded in several places..
        	
        	// replySubjectPrefix is normally 'Re: '
        	var replySubjectPrefix;
        	try {
        		replySubjectPrefix = document.getElementById("bundle_quickreplyMessages").getString('replySubjectPrefix');
                replySubjectPrefix += " ";
        	} catch (ex) {
        		QRglobals.debug(5,'doQuickReply: exception "'+ex+'" caught when getting string replySubjectPrefix, setting it to -Re: -' );
        		replySubjectPrefix = 'Re: ';
        	}
        	QRglobals.debug(15,'doQuickReply: replySubjectPrefix = "'+replySubjectPrefix+'".' );
        	if( subj.substring(0,4).toLowerCase() != replySubjectPrefix.toLowerCase() ) {
                subj = replySubjectPrefix + subj;
        	}
        	if ('newsgroups' in currentHeaderData) {
        		if ('followupto' in currentHeaderData) {
        			newsgroups = currentHeaderData['followupto'].headerValue;
        		} else {
        			newsgroups = currentHeaderData['newsgroups'].headerValue;
        	    }
                // moved this debug line up here so users are not concerned that messages are getting sent to newsgroups unless they are
        		QRglobals.debug(10, 'doQuickReply: replying to news groups: '+newsgroups);
        	} else {
        		if ('reply-to' in currentHeaderData) {
        			dest = currentHeaderData['reply-to'].headerValue;
        	    } else {
                    QRglobals.gRecips = srcMsgHdr.recipients;
                    QRglobals.gCCList = srcMsgHdr.ccList;
        			dest = srcMsgHdr.author;
        	    }
        		QRglobals.debug(10, 'doQuickReply: replying to email: '+dest);
        	}
        	var identity = QRglobals.getCurrentIdentity('initial');
        	if(!identity) {
        		QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failCurrentIdentity'),'' );
        	}
            var shouldSig = 0; 
        	var shouldQuote, defQuotePref = 0;	
        	bdy = document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).value;
        	typedbdy = bdy;
        	// do we need to quote?
            // lets just get the value from the getActiveQuoteChoice function - Frank Dilecce
    		// use the standard preference
  			defQuotePref = QRglobals.getActiveQuoteChoice();
    		QRglobals.debug(15,'doQuickReply: defQuotePref: "'+defQuotePref+'".' );
    		// add sig below - so add to bdy - no matter what happens,
    		//  it'll be in the right spot
    		if ( shouldSig == 2 ) {
    			bdy = bdy + "\n\n-- \n" + sigContent;
    		}
    		if( defQuotePref > 0 ) {
    			var orig = QRglobals.getQuotedOriginal(srcMsgHdr.author);
    			if( defQuotePref == 1 ) {
                    // we must not have the -- in the body if the quote is below the sig - Frank DiLecce
            		if ( shouldSig == 2 ) {
            			bdy = typedbdy + "\n\n" + sigContent;
            		}                
    				bdy = bdy + "\n\n" + orig;
    			} else {
    				bdy = orig + "\n" + bdy;
    			}
    		}
    		// add sig at the bottom.
    		if( shouldSig == 1 ) {
    			bdy += "\n\n-- \n" + sigContent;
    		}
            // added a linefeed to the body no matter what.. sendreply fails (on some occasions) if missing - Frank DiLecce
            bdy += "\n";
        	QRglobals.doReply(sendNow, dest, newsgroups, subj, typedbdy, srcMsgId, srcMsgURI, bdy, identity );
        	// just gonna hide the Quick Reply Box on send so the use knows something happened
            // only if the user has not chosen to keep the QRBox open ! _ Frank DiLecce
            if (!QRglobals.KeepQROpen()) {
                QRglobals.toggleQuickReplyButton(tgt);
            }
        },
    
    maybeWarnOnSend: function() {
            // Check mail.warn_on_send_accel_key, and if necessary, ask for confirmation.
            // Returns true if it's OK to send, false if not.
        	QRglobals.debug(20, 'maybeWarnOnSend: started');
            var warn = pref.getBoolPref("mail.warn_on_send_accel_key");
            var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
            var composeMsgsBundle = document.getElementById("bundle_composeMessages");
            if (warn) {
                var checkValue = {value:false};
                var buttonPressed = promptService.confirmEx(window, 
                      composeMsgsBundle.getString('sendMessageCheckWindowTitle'), 
                      composeMsgsBundle.getString('sendMessageCheckLabel'),
                      (promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0) +
                      (promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1),
                      composeMsgsBundle.getString('sendMessageCheckSendButtonLabel'),
                      null, null,
                      composeMsgsBundle.getString('CheckMsg'), 
                      checkValue);
                if (buttonPressed != 0) {
                	QRglobals.debug(10, 'maybeWarnOnSend: sending cancelled.');
                    return false;
                }
                if (checkValue.value) {
                    pref.setBoolPref("mail.warn_on_send_accel_key", false);
                }
            }
            return true;
        },
        
        // Under-the-hood stuff
    onSMIMEStartHeadersQuickReply: function() {
        },
        
    onSMIMEEndHeadersQuickReply: function() {
        	//QRglobals.ShowQuickReplyBox();
            //next line would throw an error because the element does not exist ( *I* can't find it at least) - Frank DiLecce
        	//document.getElementById("QuickReplyTarget").value = currentHeaderData["to"].headerValue ;
        },
        
    regListeners: function() {
        	var listener = {};
        	listener.onStartHeaders = QRglobals.onSMIMEStartHeadersQuickReply;
        	listener.onEndHeaders = QRglobals.onSMIMEEndHeadersQuickReply;
        	//gMessageListeners.push(listener);
        },
        
    QRMessagePaneOnLoad: function() {
            // window.setTimeout("QRglobals.regListeners()", 1000);
            // added next 10 lines so that the state of the Quick Reply box persists correctly when moving amongst folders
            // called from listener below this function - Frank DiLecce
        	QRglobals.debug(20, 'QRMessagePaneOnLoad: started');
            if (QRglobals.getViewQuickReplyToolbar('mailWindow')) {
                // if QuickRelpyToolbar is set to true we want the Quick Reply Button to show the correct value 
                //     which in this case would be "Hide Quick Reply"
            	QRglobals.debug(20, 'QRMessagePaneOnLoad: Ending, QuickReply is on');
                var toggleButton = document.getElementById("quickReplyToggleButton");
                var toggleHidden = document.getElementById("quickReplyHiddenText");
                QRglobals.gHeldButtonLabel = toggleButton.label
                toggleButton.label = toggleHidden.value;
            } else {
            	QRglobals.debug(20, 'QRMessagePaneOnLoad: Ending, QuickReply is off');
            }
        	QRglobals.regListeners();
        },
        
    QRMessagePaneOnUnload: function() {
            // called from listener below this function - Frank DiLecce
        	QRglobals.debug(20, 'QRMessagePaneOnUnLoad: triggered');
        },
        
    onComposerSendMessage: function() {
            // added to see if this is making any difference at all - Frank Dilecce
            QRglobals.debug(20, 'onComposerSendMessage: started');
            try {
                if (!QRglobals.gMsgCompose.compFields.securityInfo.requireEncryptMessage) {
                    QRglobals.debug(20, 'onComposerSendMessage: requireEncrypt is false');
                    return;
                }
                QRglobals.debug(20, 'onComposerSendMessage: requireEncrypt is true, send might fail');
                var helper = Components.classes["@mozilla.org/messenger-smime/smimejshelper;1"].createInstance(Components.interfaces.nsISMimeJSHelper);
                var emailAddresses = new Object();
                var missingCount = new Object();
                helper.getNoCertAddresses(QRglobals.gMsgCompose.compFields, missingCount, emailAddresses);
            } catch (e) {
                QRglobals.debug(20, 'onComposerSendMessage: in first catch, must not have securityInfo');
                return;
            }
            QRglobals.debug(20, 'onComposerSendMessage: helper is set');
            if (missingCount.value > 0) {
                var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
                var prefs = prefService.getBranch(null);
                var autocompleteLdap = false;
                autocompleteLdap = prefs.getBoolPref("ldap_2.autoComplete.useDirectory");
                if (autocompleteLdap) {
                    var autocompleteDirectory = null;
                    autocompleteDirectory = prefs.getCharPref("ldap_2.autoComplete.directoryServer");
                    if (QRglobals.gIdentity.overrideGlobalPref) {
                        autocompleteDirectory = QRglobals.gIdentity.directoryServer;
                    }
                }
                if (autocompleteDirectory) {
                    window.openDialog('chrome://messenger-smime/content/certFetchingStatus.xul',
                        '',
                        'chrome,resizable=1,modal=1,dialog=1', 
                        autocompleteDirectory,
                        emailAddresses.value);
                }
            }
        },
    
    markMessageReplied: function( msgURI) {
        	QRglobals.debug(20, 'markMessageReplied: started');
        	var msgHdr = messenger.messageServiceFromURI(msgURI).messageURIToMsgHdr(msgURI)  //GetMsgHdrFromUri(srcMsgURI);
        	if(!msgHdr) { return; }
        	var msgFolder = msgHdr.folder;
        	if (msgFolder) {
        		msgFolder.addMessageDispositionState(msgHdr, 0); //msgFolder.nsMsgDispositionState_Replied
        	}
        },
    
    doReplyFailed: function(why, content) {
        	QRglobals.debug(5, 'Quick Reply failed: '+why);
        	QRglobals.setStatus( why );
        	setTimeout(QRglobals.setStatus, 10000,'');
        	if( content.length > 0 ) {
        		document.getElementById("quickReplyInput" + QRglobals.GetQRBoxPosition()).value = content;
        	}
        	QRglobals.enableQR();
        	return false;
        },
        
    doReply: function( sendNow, to, newsgroups, sbj, typedbdy, srcId, srcMsgURI, bdy, identity ) {
        	QRglobals.debug(10, 'doReply: started');
           	var compfields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
        	if(!compfields) {
        		return QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failCompFields'),typedbdy);
        	}
        	QRglobals.gMsgCompose = Components.classes["@mozilla.org/messengercompose/compose;1"].createInstance(Components.interfaces.nsIMsgCompose);
        	if(!QRglobals.gMsgCompose) {
        		return QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failMsgCompose') );//"Failed to initialise compfields for quick reply."
        	}
        	var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
        	if(!params) {
        		return QRglobals.doReplyFailed(QRglobals.sQRMessagesBundle.getString('failInitParams') ); //Failed to initialise params for quick reply
        		return QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failInitParams'),typedbdy);//Failed to initialise params for quick reply
        	}
            if (to != "") { compfields.to = to; }
            if (newsgroups != "") {
                compfields.newsgroups = newsgroups;
                QRglobals.debug(15, 'doReply: newsgroups: '+newsgroups); 
            }
            compfields.subject = sbj;
            compfields.body = bdy ;
            compfields.references = "<"+ srcId +">";
            QRglobals.debug(15, 'doReply: to: '+to);
        
            // new stuff for reply all functionality - Frank DiLecce
            var replyAll = document.getElementById('QRreplyAll' + QRglobals.GetQRBoxPosition())
            if (replyAll.checked) {
                var ccs = '';
                if (QRglobals.gRecips == QRglobals.gCCList) QRglobals.gRecips = '';           // if there was no to: specified, only CCs
                if (QRglobals.gRecips != '') { ccs = QRglobals.gRecips + ', '; }  // add all recipients in case there are more than one
                ccs += QRglobals.gCCList;                               // add all the people in the cc list
                compfields.cc = ccs;                          // add all that to the compfields
                ccs = ''; 
                // now we have to remove the current user's email from the cc list
                var arr = compfields.SplitRecipients(compfields.cc, false);  // split up the recips so we don't have to deal with commas
                var recip;
                var allIdents = QRglobals.sAccountManager.allIdentities;
                for ( var index = 0; index < arr.count; index++ ) {
                    recip = null;
                    recip = arr.StringAt(index);
                    // guess we have to test against all known user identities cuz some people have had their own addess listed in the ccs
                    var isOwnAddress = false;
                    for (j= 0; j < allIdents.Count() ; j++ ) {
                        var ident = allIdents.GetElementAt(j);
                        ident instanceof Components.interfaces.nsIMsgIdentity;
                        if (recip.toLowerCase().indexOf(ident.email.toLowerCase()) > -1) {
                            isOwnAddress = true;
                            break;
                        }
                    }
                    if (isOwnAddress) {
                        // we found a recip that is the current user's email, we are not adding it to the list
                    } else {  // add all good addresses back into ccs
                        if (ccs != '') ccs += ', ';
                        ccs += recip ;
                    }
                }      
                compfields.cc = ccs;                          // replace compfields.cc with updated list
                var replyAllPersist = false;
            	try {
            		replyAllPersist = pref.getBoolPref('quickreply.persistReplyAll');
            	} catch (e) {
            		QRglobals.debug(5,'doReply: exception "'+e+'" caught when accessing preference quickreply.persistReplyAll, setting to false');
            	    pref.setBoolPref("quickreply.persistReplyAll", replyAllPersist);
            	}
                if (!replyAllPersist) replyAll.checked = false;
            }
            QRglobals.gRecips = '';
            QRglobals.gCCList = '';
        
            params.identity = identity;
            params.composeFields = compfields;
            params.format = 2;	// PlainText, otherwise we loose our formatting!
            
            
            // new stuff for using an editor in QuickReply _ frank DiLecce
            // The window below is made because the mozilla sendmsg function closes the nominated window upon completion - Frank DiLecce
            // QRhideTempWindow pref allows user to choose whether that temporary window gets shown on top of the TB window or gets 'hidden' behind it
            //  there is NO ui for it.. most people dont need it.. but those that send secure messages need it to be on top of TB
            var hideTempWindow = true;
        	try {
        		hideTempWindow = pref.getBoolPref('quickreply.hide_tempWindow');
        	} catch (e) {
        		QRglobals.debug(5,'doReply: exception "'+e+'" caught when accessing preference quickreply.hide_tempWindow, setting to true');
        	    pref.setBoolPref("quickreply.hide_tempWindow", hideTempWindow);
        	}
        	QRglobals.gHideTemp = true;
            if (hideTempWindow) {
                QRglobals.gTempEditorWindow = window.open("chrome://messenger-quickreply/content/QREditor.xul", "_blank","chrome,dialog='no',width=80,height=80,centerscreen,alwaysLowered");
            } else {
                QRglobals.gTempEditorWindow = window.open("chrome://messenger-quickreply/content/QREditor.xul", "_blank", "chrome,extrachrome,dialog='no',width=80,height=80,centerscreen,alwaysRaised");
                QRglobals.gHideTemp = false;
            }
            // get the editor element.  this element is actually our editor in the msgQuickReplyOverlay.xul but it finds it in the document object-Frank DiLecce
            var editorElement = GetCurrentEditorElement();
            // some day soon this will be html enabled, for now its text
            editorElement.makeEditable("textmail", true);
            // fill it with something
            editorElement.webNavigation.loadURI("about:blank", // uri string
                                   0,                            // load flags
                                   null,                         // referrer
                                   null,                         // post-data stream
                                   null);
            
            // initialize gMsgCompose and nominate QREditorWindow as the window to close
            QRglobals.gMsgCompose.Initialize(QRglobals.gTempEditorWindow, params );
            QRglobals.gSendNow = sendNow;
            QRglobals.gSrcMsgURI = srcMsgURI;
            QRglobals.gTypedBdy = typedbdy;
            // start the command observer to wait for the editor to be initialized
            // need to do this or text is not checked for character set conversion
            QRglobals.debug(20, 'doReply: starting command observer');
            if (QRglobals.gHideTemp) {
                setTimeout("QRglobals.gTempEditorWindow.minimize()",1);
            }
            editorElement.commandManager.addCommandObserver(QRglobals.gMsgEditorCreationObserver, "obs_documentCreated");
            QRglobals.debug(20, 'doReply: Ending');
        },
        
    DoSend: function() {
            // Things in this function that must be done regardless of sending success are :
            // set gMsgCompose to null
            // unregister progresslistener
            // remove the editorelement's command observer
            // clear the editor - haven't figured this out yet, for now it gets overwritten ?
            // the temporary window *Should* get closed by the mozilla sendMsg function but we will do it in the catch at the end
            //   of this function if we have to - Frank DiLecce
            QRglobals.debug(20, 'doSend: starting');
            var identity = QRglobals.gIdentity;
            // added next two vars for the progress bar - Frank DiLecce
            var statusBar = document.getElementById("statusbar-progresspanel");
            var statusBarIcon = document.getElementById("statusbar-icon");
            var progressListener = {
                srcMessageId: String,
                onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
                    if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_START) {
                        QRglobals.setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusStartingSend') );
                        // init the progress bar and altprogress vars - Frank DiLecce
                        statusBar.collapsed = false
                        statusBarIcon.setAttribute( "mode", "normal" );
                        QRglobals.gAltProgress = 0;
                    }
                  
                    if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
                        // we are done sending/saving the message...
                        // Indicate completion in status area.
        				QRglobals.clearQR();
        				QRglobals.enableQR();
        				QRglobals.setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusMessageSent') );
                        statusBarIcon.setAttribute("mode","normal");
                        // Need to put everything to do with progress bar back to normal - Frank DiLecce
                        statusBarIcon.value = 0;  
                        statusBarIcon.label = "";
                        statusBar.collapsed = true;
        				window.setTimeout(QRglobals.setStatus, 3000, '');
        				QRglobals.markMessageReplied( this.srcMsgURI );
        				QRglobals.debug(5, 'onStateChange: message sent');
                        // Need to put everything else back to normal - Frank DiLecce
                        QRglobals.gMsgCompose = null;
                        QRglobals.gSendNow = null;
                        QRglobals.gSrcMsgURI = null;
                        QRglobals.gTypedBdy = null;
                    	progress.unregisterListener(progressListener);    
                        GetCurrentEditorElement().commandManager.removeCommandObserver(QRglobals.gMsgEditorCreationObserver, "obs_documentCreated");
                        GetCurrentEditorElement().makeEditable("textmail", false);
                    }
                },
                
                onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
                    // Changed the whole ProgressChange Function to match TB's own (to a point) - Frank DiLecce
                    // Calculate percentage.
                    var percent;
                    QRglobals.debug(10, 'onStatusChange: '+aCurSelfProgress + " " +  aMaxSelfProgress + " " +  aCurTotalProgress + " " + aMaxTotalProgress);
                    if ( aMaxTotalProgress > 0 ) { 
                        percent = Math.round( (aCurTotalProgress*100)/aMaxTotalProgress ); 
                        if ( percent > 100 ) { percent = 100; }
                        QRglobals.setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusMessageSending') + '  ' + percent + '% ' );
                        // this sets the progress bar value - Frank DiLecce
                        statusBar.collapsed = false;
                        statusBarIcon.value = percent; 
                        statusBarIcon.label = percent + "%"
                    } else {
                        // Progress meter should be barber-pole in this case.
                        // yea right! , aMaxTotalProgress is always -1 for some reason and the aCurTotalProgress starts at 20 something
                        //  and goes up to 1300 something ??  
                        //  but it goes from say 150 to 30 to 180 to 50 etc.  so we save the highest value and only adjust if
                        //  an incoming value is greater than that then
                        //  I'm just gonna divide by 10 and max out at 100 - Frank DiLecce 
                        if (aCurTotalProgress > QRglobals.gAltProgress) {
                            QRglobals.gAltProgress = aCurTotalProgress ;
                            percent = Math.round(aCurTotalProgress/10);
                            if ( percent > 100 ) { percent = 100; }
                            QRglobals.setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusMessageSending') + '  ' + percent + '%' );
                            statusBar.collapsed = false;
                            statusBarIcon.value = percent; 
                            statusBarIcon.label = percent + "%"
                            QRglobals.debug(10, 'onStatusChange:max is -1 percent is '+percent+ ' statbar is ' + document.getElementById("statusbar-progresspanel").getAttribute( "mode"));
                        }              
                    }
                },
            
            	onLocationChange: function(aWebProgress, aRequest, aLocation) {
                },
            
                onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {
        			// Looks like it's possible that we get call while the document has been already deleted!
        			// therefore we need to protect ourself by using try/catch
        			QRglobals.debug(10, 'onStatusChange: '+aStatus+':'+aMessage+'.');
        			try {
        				QRglobals.setStatus( aMessage );
        				if(aMessage == document.getElementById("bundle_quickreplyMessages").getString('copyCompleteHack') ) { 
        				    // XX dirty hack! Otherwise, the message lingers. -- hard to localise, too
        					setTimeout("QRglobals.setStatus('');QRglobals.clearQR();QRglobals.enableQR();", "3000");
        				}
        			} catch (e) {
        				QRglobals.debug(5,'onStatusChange: exception "'+e+'" caught when getting string copyCompleteHack');
        			};
        		},
            
                onSecurityChange: function(aWebProgress, aRequest, state) {
                },
            
                QueryInterface : function(iid) {
                    if (iid.equals(Components.interfaces.nsIWebProgressListener) ||
                            iid.equals(Components.interfaces.nsISupportsWeakReference) ||
                            iid.equals(Components.interfaces.nsISupports))
                        return this;
                    throw Components.results.NS_NOINTERFACE;
                }
            };
        
            // alert any observers that may be looking for a composeOnSend event
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.notifyObservers(window, "mail:composeOnSend", null);
        	var progress = Components.classes["@mozilla.org/messenger/progress;1"].createInstance(Components.interfaces.nsIMsgProgress);
        	if(!progress) {
        		return QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failInitProgress'),QRglobals.gTypedBdy ); //Failed to initialise progress for quick reply.
        	}
        	progress.registerListener(progressListener);
        	progressListener.srcMsgURI = QRglobals.gSrcMsgURI;
        
            // set up a fallback character set should the message text need it
            var fallbackCharset = new Object;
            var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
            if (promptService && !QRglobals.gMsgCompose.checkCharsetConversion(QRglobals.gIdentity, fallbackCharset)) {
                var dlgTitle = document.getElementById("bundle_quickreplyMessages").getString('initErrorDlogTitle');
                var dlgText = document.getElementById("bundle_quickreplyMessages").getString('12553'); // NS_ERROR_MSG_MULTILINGUAL_SEND
                if (!promptService.confirm(window, dlgTitle, dlgText)) 
                    {}
                else {
                    fallbackCharset.value = "UTF-8";
            		QRglobals.debug(5, 'doReply: in fallbackCharset set to UTF-8');
                }
            }
            if (fallbackCharset && fallbackCharset.value && fallbackCharset.value != "") {
                QRglobals.gMsgCompose.SetDocumentCharset(fallbackCharset.value);
            }
            promptService = null;


            // just before we try to send the message, fire off the compose-send-message event for listeners
            // such as smime so they can do any pre-security work such as fetching certificates before sending
            // !!! this is a hard one to emulate, cannot mimic it completely because it's well
            // tied in to the real Compose window.. looks like encryption may not work right because its not fully set up 
            // this is commented out for the time being until we can figure out how to make it work
            //var event = document.createEvent('Events');
            //event.initEvent('compose-send-message', false, true);
            //document.getElementById("messengerWindow").dispatchEvent(event);
        
        
            // Lets get the account for this folder, needed for SendMsg - Frank DiLecce
            var account =  QRglobals.sAccountManager.FindAccountForServer(GetLoadedMsgFolder().server);
            // The default compose window sendmsg function has it, needed for SendMsg - Frank DiLecce
        	QRglobals.debug(20, 'doSend: account key to use ' + account.key);
        	QRglobals.debug(20, 'doSend: identity key to use ' + identity.key);
            // now is probably the best time to try linking in to enigmail
            try {
                var enigAgent = pref.getCharPref('extensions.enigmail.agentPath');
                // if we are here, enigmail is assumed to be installed
                QRglobals.enigEncrypt();
            } catch(e) {
                // enigmail is NOT installed, lets just continue
            }
            msgWindow.SetDOMWindow(window);
            // wrap that text !
            QRglobals.gMsgCompose.editor.QueryInterface(Components.interfaces.nsIPlaintextEditor).wrapWidth = QRglobals.gMsgCompose.wrapLength;
            
            // the next line was responsible for mangling quoted text.. it strips CRs apparently.
            //GetCurrentEditor().QueryInterface(Components.interfaces.nsIEditorMailSupport).rewrap(true);    
            
            // Ahh we are finally going to send this reply to grandad
        	try {
                // if we are offline, send later
                var deliverMode = Components.interfaces.nsIMsgCompDeliverMode;

        		if( QRglobals.gSendNow && !QRglobals.sIOService.offline) {
        			QRglobals.debug(5, 'doSend: initiating send now');
                    // I know I told everyone that making it work for TB0.5 milestone was not reccommended, I put it in anyway - Frank DiLecce
                    try {
                        // Mozilla >= 1.7a
                        QRglobals.gMsgCompose.SendMsg(deliverMode.Now, identity, account.key, msgWindow, progress);
                    } catch(e) {
                        //Mozilla <= 1.6
                        try {
                            QRglobals.gMsgCompose.SendMsg(deliverMode.Now, identity, msgWindow, progress);
                        } catch (e) {
                     	    QRglobals.resetSend(e);
                            progress.unregisterListener(progressListener);    
                        }
                    }
            	} else {
                    if (QRglobals.gSendNow && QRglobals.sIOService.offline) {
                        QRglobals.debug(5, 'doSend: user tried to use sendnow but TB offline so initiating send later');
                    } else {
                        QRglobals.debug(5, 'doSend: initiating send later');
                    }
                    try {
                        // Mozilla >= 1.7a
                        QRglobals.gMsgCompose.SendMsg(deliverMode.Later, identity, account.key, msgWindow, progress);
                    } catch(e) {
                        //Mozilla <= 1.6
                        try {
                            QRglobals.gMsgCompose.SendMsg(deliverMode.Later, identity, msgWindow, progress);
                        } catch (e) {
                     	    QRglobals.resetSend(e);
                            progress.unregisterListener(progressListener);    
                       }
                    }
        		}
        	} catch(e) {
        	    QRglobals.resetSend(e);
                progress.unregisterListener(progressListener);    
        	}
        },

    resetSend: function(errr) {
                QRglobals.gTempEditorWindow.close();
                alert(errr);
        		QRglobals.debug(5, errr);
        		return QRglobals.doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failMsgSend') + " >>" + errr,	QRglobals.gTypedBdy);
                QRglobals.gMsgCompose = null;
                QRglobals.gSendNow = null;
                QRglobals.gSrcMsgURI = null;
                QRglobals.gTypedBdy = null;
                GetCurrentEditorElement().commandManager.removeCommandObserver(QRglobals.gMsgEditorCreationObserver, "obs_documentCreated");
                GetCurrentEditorElement().makeEditable("textmail", false);
    
        },
        
    enigGetAccDefault: function(value) {
                var enabled = QRglobals.gIdentity.getBoolAttribute("enablePgp");
                if (value == "enabled")
                    return enabled;
                if (enabled) {
                    switch (value) {
                    case 'encrypt':
                        return QRglobals.gIdentity.getIntAttribute("defaultEncryptionPolicy");
                    case 'signPlain':
                        return QRglobals.gIdentity.getBoolAttribute("pgpSignPlain");
                    case 'signEnc':
                        return QRglobals.gIdentity.getBoolAttribute("pgpSignEncrypted");
                    }
                } else {
                    switch (value) {
                    case 'encrypt':
                        return 0;
                    case 'signPlain':
                    case 'signEnc':
                        return false;
                    }
                }
        },
    
    enigEncrypt: function(someVar) {
	        QRglobals.debug(20, 'enigEncrypt: started');
                EnigInitCommon("enigmail_QR");
                gEnigSendMode = 0;  // start by setting no ecryption
                // perform checks on whether to encrypt (and sign) reply
                var origIsEncrypted = false;
                var enigMimeService = Components.classes[ENIG_ENIGMIMESERVICE_CONTRACTID].getService(Components.interfaces.nsIEnigMimeService);
                if (enigMimeService) {
                    if (enigMimeService.isEncrypted(QRglobals.gSrcMsgURI)) {
                        origIsEncrypted = true;
                    }
                }
                var QREncRep = false;
            	try {
            		QREncRep = pref.getBoolPref( 'quickreply.encryptEnig');
            	} catch (e) {
            		QRglobals.debug(5,'QRKeepOpen: exception "'+e+'" caught when accessing preference quickreply.encryptEnig');
            		QREncRep = false;
            		pref.setBoolPref( 'quickreply.encryptEnig', false );
            	}
                
                if (origIsEncrypted) {
                    if (QREncRep) {
                        gEnigSendMode |= ENIG_ENCRYPT;
                        var QRSignRep = false;
                    	try {
                    		QRSignRep = pref.getBoolPref( 'quickreply.signEncryptEnig');
                    	} catch (e) {
                    		QRglobals.debug(5,'QRKeepOpen: exception "'+e+'" caught when accessing preference quickreply.signEncryptEnig');
                    		QRSignRep = false;
                    		pref.setBoolPref( 'quickreply.signEncryptEnig', QRSignRep );
                    	}
                        if (QRSignRep) gEnigSendMode |= ENIG_SIGN;
                    } else {
                        // we will not encrypt this cuz the prefs says not to encrypt replies
            	        QRglobals.debug(20, 'enigEncrypt: ending, User pref set to not encrypt replies so not encrypting reply');
            	        return;
                    }
                } else {
                    // we will not encrypt this cuz the original is not encrypted
        	        QRglobals.debug(20, 'enigEncrypt: ending, Original message is not encrypted so not encrypting reply');
        	        return;
                }
                var gotSendFlags = gEnigSendMode;
                var sendFlags=0;
                if (gotSendFlags & ENIG_SIGN)  sendFlags |= ENIG_SIGN;
                if (gotSendFlags & ENIG_ENCRYPT) sendFlags |= ENIG_ENCRYPT;
                var encryptIfPossible = true;
                var enigmailSvc = GetEnigmailSvc();
                QRglobals.temp1 = enigmailSvc;
                if (!enigmailSvc) {
        	        QRglobals.debug(20, 'enigEncrypt: ending, Enigmail service could not be initialized, not encrypting reply');
                    return;
                }
                try {
                    var exitCodeObj    = new Object();
                    var statusFlagsObj = new Object();
                    var errorMsgObj    = new Object();
                    var gEnigAccountId = QRglobals.gIdentity;
                    var fromAddr = gEnigAccountId.email;
                    var pgpEnabled = QRglobals.enigGetAccDefault("enabled");
                    if (!pgpEnabled) {
              	        QRglobals.debug(20, 'enigEncrypt: Email address ' + fromAddr + ' Not Configured for Enigmail, not encrypting reply');
                        return;
                    }
                    var recipientsSelectionOption = EnigGetPref("recipientsSelectionOption");
                    var optSendFlags = 0;
                    if (EnigGetPref("alwaysTrustSend")) { optSendFlags |= nsIEnigmail.SEND_ALWAYS_TRUST; }
                    if (EnigGetPref("encryptToSelf")) { optSendFlags |= nsIEnigmail.SEND_ENCRYPT_TO_SELF; }
                    sendFlags |= optSendFlags;
	                QRglobals.debug(20, 'enigEncrypt: Enig Send Flags>' + sendFlags);
                    if (gEnigAccountId.getIntAttribute("pgpKeyMode")>0) {
                        var userIdValue = gEnigAccountId.getCharAttribute("pgpkeyId");
                        if (!userIdValue) {
                            var mesg = EnigGetString("composeSpecifyEmail");
                            var valueObj = new Object();
                            valueObj.value = userIdValue;
                            if (EnigPromptValue(mesg, valueObj)) {
                                userIdValue = valueObj.value;
                            }
                        }
                        if (userIdValue) {
                            fromAddr = userIdValue;
                            gEnigAccountId.setCharAttribute("pgpkeyId", userIdValue);
                        } else {
                            gEnigAccountId.setIntAttribute("pgpKeyMode", 0);
                        }
                    }
                    var msgCompFields = QRglobals.gMsgCompose.compFields;
                    //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg:gMsgCompose="+gMsgCompose+"\n");
                    var toAddrList = [];
                    if (msgCompFields.to)  toAddrList.push(msgCompFields.to);
                    if (msgCompFields.cc)  toAddrList.push(msgCompFields.cc);
                    if (msgCompFields.bcc) {
                         toAddrList.push(msgCompFields.bcc);
                         var bccLC = EnigStripEmail(msgCompFields.bcc).toLowerCase()
                         //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: BCC: "+bccLC+"\n");
                         var selfBCC = gEnigAccountId.email && (gEnigAccountId.email.toLowerCase() == bccLC);
                         if (selfBCC) {
                             //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: Self BCC\n");
                         } else if (sendFlags & ENIG_ENCRYPT) {
                             // BCC and encryption
                             QRglobals.debug(20, 'enigEncrypt: sending BCC so not encrypting message')
                             return;
                         }
                     }
                     // Check if sending to any newsgroups
                     var newsgroups = msgCompFields.newsgroups;
                     if (newsgroups) {
                         QRglobals.debug(20, 'enigEncrypt: sending BCC so not encrypting message')
                         return;
                    }
                    //var usePGPMimeOption = EnigGetPref("usePGPMimeOption");
                    //if (gEnigSendPGPMime) {
                    //    sendFlags |= nsIEnigmail.SEND_PGP_MIME;
                    //}
                    var toAddr = toAddrList.join(", ");
                    var testCipher = null;
                    if (toAddr.length>=1) {
                        var perRecipientRules=EnigGetPref("perRecipientRules");
                        var repeatSelection=3;
                        // not doing per recipent rules
                        while (repeatSelection<2) {
                            if (perRecipientRules>0) {
                                var matchedKeysObj  =new Object;
                                var flagsObj=new Object;
                                if (!getRecipientsKeys(toAddr, (repeatSelection==1),matchedKeysObj, flagsObj)) {
                                    window.cancelSendMessage=true;
                                    return;
                                }
                                if (matchedKeysObj.value) toAddr=matchedKeysObj.value;
                                if (flagsObj.value != -1) {
                                    // sign:    0x0001 | 0x0002 => 3
                                    // encrypt: 0x0004 | 0x0008 => 12
                                    // pgpMime: 0x0010 | 0x0020 => 48
                                    switch (flagsObj.value & 3) {
                                        // sign
                                        case 0:
                                            sendFlags &= ~ENIG_SIGN;
                                            break;
                                        case 2:
                                            sendFlags |= ENIG_SIGN;
                                            break;
                                    }
                                    switch ((flagsObj.value & 12)>>2) {
                                        // encrypt
                                        case 0:
                                            sendFlags &= ~ENIG_ENCRYPT;
                                            break;
                                        case 2:
                                            sendFlags |= ENIG_ENCRYPT;
                                            break;
                                    }
                                    switch ((flagsObj.value & 48)>>4) {
                                        // pgpMime
                                        case 0:
                                            sendFlags &= ~nsIEnigmail.SEND_PGP_MIME;
                                            break;
                                        case 2:
                                            sendFlags |= nsIEnigmail.SEND_PGP_MIME;
                                            break;
                                    }
                                }
                            }
                            
                            repeatSelection++;
                            if (sendFlags & ENIG_ENCRYPT) {
                                // Encrypt test message for default encryption
                                var testExitCodeObj    = new Object();
                                var testStatusFlagsObj = new Object();
                                var testErrorMsgObj    = new Object();
                        
                                var testPlain = "Test Message";
                                var testUiFlags   = nsIEnigmail.UI_TEST;
                                var testSendFlags = nsIEnigmail.SEND_ENCRYPTED |
                                                    nsIEnigmail.SEND_TEST |
                                                    optSendFlags;
                        
                                // test recipients
                                testCipher = enigmailSvc.encryptMessage(window, testUiFlags,
                                                                      testPlain,
                                                                      fromAddr, toAddr,
                                                                      testSendFlags,
                                                                      testExitCodeObj,
                                                                      testStatusFlagsObj,
                                                                      testErrorMsgObj);
                                if ((recipientsSelectionOption==2) || ((testStatusFlagsObj.value & nsIEnigmail.INVALID_RECIPIENT) && (recipientsSelectionOption>0))) {
                                    var resultObj = new Object();
                                    var inputObj = new Object();
                                    inputObj.toAddr = toAddr;
                                    inputObj.options = "multisel";
                                    if (perRecipientRules<2) inputObj.options += ",rulesOption"
                                    //if (notSignedIfNotEnc) inputObj.options += ",notsigned";
                                    if (recipientsSelectionOption<2) inputObj.options += ",noforcedisp";
                                    inputObj.dialogHeader = EnigGetString("recipientsSelectionHdr");
                                    window.openDialog("chrome://enigmail/content/enigmailUserSelection.xul","", "dialog,modal,centerscreen", inputObj, resultObj);
                                    try {
                                        if (resultObj.cancelled) {
                                            window.cancelSendMessage=true;
                                            return;
                                        }
                                        if (resultObj.perRecipientRules) {
                                            // do an extra round because the user want to set a PGP rule
                                            continue;
                                        }
                                        if (! resultObj.encrypt) {
                                            // encryption explicitely turned off
                                            sendFlags &= ~ENIG_ENCRYPT;
                                        } else {
                                            toAddr = resultObj.userList.join(", ");
                                        }
                                        testCipher="ok";
                                        testExitCodeObj.value = 0;
                                    } catch (ex) {
                                        // cancel pressed -> don't send mail
                                        EnigAlert("Something went wrong 1"); // REMOVE
                                        window.cancelSendMessage=true;
                                        return;
                                    }
                                }
                                if ((!testCipher || (testExitCodeObj.value != 0)) && recipientsSelectionOption==0) {
                                    // Test encryption failed; turn off default encryption
                                    sendFlags &= ~ENIG_ENCRYPT;
                                    DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: No default encryption because test failed\n");
                                }
                            }
                            repeatSelection=2;
                        } // end of per recipient rules 
                        if ((gotSendFlags & ENIG_ENCRYPT) && !(sendFlags & ENIG_ENCRYPT)) {
                            // Default encryption turned off; turn off signing as well
                            if (gEnigSendModeDirty<2 && (! enigGetAccDefault("signPlain"))) {
                                sendFlags  &= ~ENIG_SIGN;
                            }
                        }
                    }
                    var usingPGPMime = (sendFlags & nsIEnigmail.SEND_PGP_MIME) && (sendFlags & ENIG_ENCRYPT_OR_SIGN);
                    if (usingPGPMime && !enigmailSvc.composeSecure) {
                        if (!EnigConfirm(EnigGetString("noPGPMIME"))) {
                            throw Components.results.NS_ERROR_FAILURE;
                        }
                        usingPGPMime = false;
                    }
                    var uiFlags = nsIEnigmail.UI_INTERACTIVE;
                    if (usingPGPMime) uiFlags |= nsIEnigmail.UI_PGP_MIME;
                    var gEnigProcessed = null;
                    if ((sendFlags & ENIG_ENCRYPT_OR_SIGN) && usingPGPMime) {
                        // really should not allow this
                        // Use EnigMime
                        //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: Using EnigMime, flags="+sendFlags+"\n");
                        var oldSecurityInfo = QRglobals.gMsgCompose.compFields.securityInfo;
                        //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: oldSecurityInfo = "+oldSecurityInfo+"\n");
                        var newSecurityInfo;
                        if (!oldSecurityInfo) {
                            try {
                                newSecurityInfo = oldSecurityInfo.QueryInterface(Components.interfaces.nsIEnigMsgCompFields);
                            } catch (ex) {}
                        }
                        if (!newSecurityInfo) {
                            newSecurityInfo = Components.classes[ENIG_ENIGMSGCOMPFIELDS_CONTRACTID].createInstance(Components.interfaces.nsIEnigMsgCompFields);
                            if (!newSecurityInfo) throw Components.results.NS_ERROR_FAILURE;
                            newSecurityInfo.init(oldSecurityInfo);
                            QRglobals.gMsgCompose.compFields.securityInfo = newSecurityInfo;
                        }
                        newSecurityInfo.sendFlags = sendFlags;
                        newSecurityInfo.UIFlags = uiFlags;
                        newSecurityInfo.senderEmailAddr = fromAddr;
                        newSecurityInfo.recipients = toAddr;
                        newSecurityInfo.hashAlgorithm = gMimeHashAlgorithms[EnigGetPref("mimeHashAlgorithm")];
                        //DEBUG_LOG("enigmailMsgComposeOverlay.js: enigEncryptMsg: securityInfo = "+newSecurityInfo+"\n");
                    } else if (!gEnigProcessed && (sendFlags & ENIG_ENCRYPT_OR_SIGN)) {
                        try {
                            if (gEnigPrefRoot.getBoolPref("mail.strictly_mime")) {
                                if (EnigConfirmPref(EnigGetString("quotedPrintableWarn"), "quotedPrintableWarn")) {
                                    gEnigPrefRoot.setBoolPref("mail.strictly_mime", false);
                                }
                            }
                        } catch (ex) {}
                        var sendFlowed = true;
                        try {
                            sendFlowed = gEnigPrefRoot.getBoolPref("mailnews.send_plaintext_flowed");
                        } catch (ex) {}
                        var EnigOutputFormatted     = 2;
                        var EnigOutputLFLineBreak   = 1024;
                        var encoderFlags = EnigOutputFormatted | EnigOutputLFLineBreak;
                        var wrapWidth=72;
                        try {
                            wrapWidth = gEnigPrefRoot.getIntPref("mailnews.wraplength");
                            if (wrapWidth<68) {
                                if (EnigConfirm(EnigGetString("minimalLineWrapping", wrapWidth))) {
                                    gEnigPrefRoot.setIntPref("mailnews.wraplength", 68)
                                }
                            }
                        } catch (ex) {}
                        // Get plain text
                        // (Do we need to set the nsIDocumentEncoder::* flags?)
                        var origText = QRglobals.gMsgCompose.editor.outputToString("text/plain", encoderFlags);
	                    QRglobals.debug(20, 'enigEncrypt: original message text>' + origText + '<');
                        // Copy plain text for possible escaping
                        var escText = origText;
                        if (sendFlowed && !(sendFlags & ENIG_ENCRYPT)) {
                            // Prevent space stuffing a la RFC 2646 (format=flowed).
                            // MULTILINE MATCHING ON
                            RegExp.multiline = true;
                            escText = escText.replace(/^From /g, "~From ");
                            escText = escText.replace(/^>/g, "|");
                            escText = escText.replace(/^[ \t]+$/g, "");
                            escText = escText.replace(/^ /g, "~ ");
                            // MULTILINE MATCHING OFF
                            RegExp.multiline = false;
                            // Replace plain text and get it again
	                        QRglobals.gMsgCompose.editor.selectAll();
                            QRglobals.gMsgCompose.editor.insertText(escText);
                            escText = QRglobals.gMsgCompose.editor.outputToString("text/plain", encoderFlags);
                        }
                        // Replace plain text and get it again (to avoid linewrapping problems)
	                    QRglobals.gMsgCompose.editor.selectAll();
                        QRglobals.gMsgCompose.editor.insertText(escText);
                        escText = QRglobals.gMsgCompose.editor.outputToString("text/plain", encoderFlags);
                        if (!escText) {
                            // No encryption or signing for null text
                            sendFlags &= ~ENIG_ENCRYPT_OR_SIGN;
                        } else {
                            // Encrypt plaintext
                            var charset = QRglobals.gMsgCompose.editor.documentCharacterSet;
                            // Encode plaintext to charset from unicode
                            var plainText = (sendFlags & ENIG_ENCRYPT) ? EnigConvertFromUnicode(origText, charset) : EnigConvertFromUnicode(escText, charset);
                            exitCodeObj    = new Object();
                            statusFlagsObj = new Object();
                            errorMsgObj    = new Object();
                	        QRglobals.debug(20, 'enigEncrypt: Going to encrypt, uiFlags>' + uiFlags);
                	        QRglobals.debug(20, 'enigEncrypt: Going to encrypt, text>' + plainText);
                	        QRglobals.debug(20, 'enigEncrypt: Going to encrypt, fromAddr>' + fromAddr);
                	        QRglobals.debug(20, 'enigEncrypt: Going to encrypt, toAddr>' + toAddr);
                	        QRglobals.debug(20, 'enigEncrypt: Going to encrypt, sendFlags>' + sendFlags);
                            var cipherText = enigmailSvc.encryptMessage(window,uiFlags, plainText, fromAddr, toAddr, sendFlags, exitCodeObj, statusFlagsObj, errorMsgObj);
                            var exitCode = exitCodeObj.value;
                            if (cipherText && (exitCode == 0)) {
                	            QRglobals.debug(20, 'enigEncrypt: Encryption succeeded');
                                // Encryption/signing succeeded; overwrite plaintext
                                if ( (sendFlags & ENIG_ENCRYPT) && charset && (charset.search(/^us-ascii$/i) != 0) ) {
                                    // Add Charset armor header for encrypted blocks
                                    cipherText = cipherText.replace(/(-----BEGIN PGP MESSAGE----- *)(\r?\n)/, "$1$2Charset: "+charset+"$2");
                                }
                                // Decode ciphertext from charset to unicode and overwrite
	                            QRglobals.gMsgCompose.editor.selectAll();
                                QRglobals.gMsgCompose.editor.insertText(EnigConvertToUnicode(cipherText, charset));
                                // Save original text (for undo)
                                var gProcessed = {"origText":origText, "charset":charset};
                            } else {
                                // Restore original text
	                            QRglobals.gMsgCompose.editor.selectAll();
                                QRglobals.gMsgCompose.editor.insertText(origText);
                                if (sendFlags & ENIG_ENCRYPT_OR_SIGN) {
                                    // Encryption/signing failed
                                    EnigAlert(EnigGetString("sendAborted")+errorMsgObj.value);
                    	            QRglobals.debug(20, 'enigEncrypt: Encryption failed, EncryptMessage exitcode>' + exitCode);
                                    return;
                                }
                            }
                        }
                    }
                } catch (ex) {
	               QRglobals.debug(20, 'enigEncrypt: not encypting, Caught Error e>' + ex);
                    var msg=EnigGetString("signFailed");
                    if (gEnigmailSvc && gEnigmailSvc.initializationError) {
                        msg += "\n"+gEnigmailSvc.initializationError;
                    }
                }
	        QRglobals.debug(20, 'enigEncrypt: Function Ending');
        }
}    


// static globals, need to be initialized only once
QRglobals.sQRMessagesBundle = document.getElementById("bundle_quickreplyMessages");
QRglobals.sIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
QRglobals.sAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
try {
	QRglobals.gDebugLevel = pref.getIntPref( 'quickreply.debug' );
} catch(e) {
    // If the debug level pref was unavailable, can only assume no default prefs were set.. lets set them now - Frank DiLecce
    QRglobals.saveDefaultPrefs();
}
addEventListener("messagepane-loaded", QRglobals.QRMessagePaneOnLoad, true);
addEventListener("messagepane-unloaded", QRglobals.QRMessagePaneOnUnload, true);
// we cannot use the next line until we have viable SMIME functions
//addEventListener('compose-send-message', QRglobals.onComposerSendMessage, true);
